      program xu2vtk
      implicit none
      integer maxn,dim,maxnel,dim1
      parameter (maxn=999999,dim=3,maxnel=999999,dim1=dim+1)
      integer i,j,point_id,n,nel,ncell
      data n/0/,nel/0/,ncell/0/
      integer cells(maxnel,dim)
      double precision x,y,point_data,z
      double precision points(maxn,dim1)
      do i=1,maxn
         read(UNIT=5,ERR=10,END=20,FMT=*) x,y,z,point_data,point_id
         n=max(n,point_id)
         points(point_id,1)=x
         points(point_id,2)=y
         points(point_id,3)=z
         points(point_id,4)=point_data
         ncell=nel/dim+1
         cells(ncell,mod(nel,dim)+1)=point_id-1
         nel=nel+1
 10      continue
      end do
      write(6,*) 'maxn',maxn,' too small'
      stop
 20   continue
      write(6,1) '# vtk DataFile Version 4.2'
      write(6,1) 'Unstructured Grid Example '
      write(6,1) 'ASCII                     '
      write(6,1) 'DATASET UNSTRUCTURED_GRID '
      write(6,2) 'POINTS',n,'float'
      write(6,3) ((points(i,j),j=1,dim),i=1,n)
      write(6,*)
      write(6,4) 'CELLS',ncell,dim1*ncell
      do i=1,ncell
         write(6,5) dim,(cells(i,j),j=1,dim)
      end do   
      write(6,*)
      write(6,6) 'CELL_TYPES',ncell
      do i=1,ncell
         write(6,7) 5
      end do   
      write(6,*)
      write(6,6) 'POINT_DATA',n
      write(6,1) 'SCALARS scalars float 1   '
      write(6,1) 'LOOKUP_TABLE default      '
      write(6,8) (points(i,dim1),i=1,n)
 1    format(a26)
 2    format(a6,1x,i6,1x,a5)
 3    format(1x,e10.4,1x,e10.4,1x,e10.4,1x)
 4    format(a5,1x,i6,1x,i7)
 5    format(i1,3(1x,i6))
 6    format(a10,1x,i6)
 7    format(i2)
 8    format(1x,e10.4,1x)
      stop
      end   
